com.io7m.jregions.core.parameterized.areas

## Class PAreaI<S>

- java.lang.Object
- - com.io7m.jregions.core.parameterized.areas.PAreaI<S>

- Type Parameters:
    `S` - A phantom type parameter indicating the coordinate space of the area
  All Implemented Interfaces:
    PAreaIType<S>

      @Generated(value={"Immutables.generator","PAreaIType<S>"})
      public final class PAreaI<S>
      extends Object
      implements PAreaIType<S>

  An area with `int` coordinates.

  The coordinates of the area are given in half-closed form. That is, `minimumX()` refers to the minimum inclusive value on the X axis, and `maximumX()` refers to the maximum exclusive value on the X axis. Likewise for the Y axis.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `PAreaI.Builder<S>` Builds instances of type `PAreaI`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <S> PAreaI.Builder<S>` | `builder()` Creates a builder for `PAreaI`.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `PAreaI` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
    `int` | `height()`
    `int` | `maximumX()`
    `int` | `maximumY()`
    `int` | `minimumX()`
    `int` | `minimumY()`
    `static <S> PAreaI<S>` | `of(int minimumX, int maximumX, int minimumY, int maximumY)` Construct a new immutable `PAreaI` instance.
    `String` | `toString()` Prints the immutable value `PAreaI` with attribute values.
    `int` | `width()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.jregions.core.parameterized.areas.PAreaIType

      `checkPreconditions`

- - ### Method Detail

    - #### minimumX

          public int minimumX()

      Specified by:
        `minimumX` in interface `PAreaIType<S>`
      Returns:
        The value on the X axis of the minimum edge of the box (inclusive)

    - #### maximumX

          public int maximumX()

      Specified by:
        `maximumX` in interface `PAreaIType<S>`
      Returns:
        The value on the X axis of the maximum edge of the box (exclusive)

    - #### minimumY

          public int minimumY()

      Specified by:
        `minimumY` in interface `PAreaIType<S>`
      Returns:
        The value on the Y axis of the minimum edge of the box (inclusive)

    - #### maximumY

          public int maximumY()

      Specified by:
        `maximumY` in interface `PAreaIType<S>`
      Returns:
        The value on the Y axis of the maximum edge of the box (exclusive)

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `PAreaI` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `PAreaI` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### width

          public int width()

      Returns a lazily initialized value of the `width` attribute. Initialized once and only once and stored for subsequent access with proper synchronization.

      Specified by:
        `width` in interface `PAreaIType<S>`
      Returns:
        A lazily initialized value of the `l.name` attribute

    - #### height

          public int height()

      Returns a lazily initialized value of the `height` attribute. Initialized once and only once and stored for subsequent access with proper synchronization.

      Specified by:
        `height` in interface `PAreaIType<S>`
      Returns:
        A lazily initialized value of the `l.name` attribute

    - #### of

          public static <S> PAreaI<S> of(int minimumX,
                                         int maximumX,
                                         int minimumY,
                                         int maximumY)

      Construct a new immutable `PAreaI` instance.
      Parameters:
        `minimumX` - The value for the `minimumX` attribute
        `maximumX` - The value for the `maximumX` attribute
        `minimumY` - The value for the `minimumY` attribute
        `maximumY` - The value for the `maximumY` attribute
      Returns:
        An immutable PAreaI instance

    - #### builder

          public static <S> PAreaI.Builder<S> builder()

      Creates a builder for `PAreaI`.
      Type Parameters:
        `S` - generic parameter S
      Returns:
        A new PAreaI builder

Copyright © 2017 <code@io7m.com> http://io7m.com